/********************************************************************/
/*                                                                  */
/* INSTALL programm for LYNX/2 2.8.5                                */
/*                                                                  */
/* Author: Michel SUCH. Email: msuch@free.fr                        */
/*                                                                  */
/********************************************************************/

   call init_prog
   call build_dirs
   call build_starter
   call update_desktop
   say lynx "installed successfully!"
exit /* main */


init_prog:

   if RxfuncQuery('sysloadfuncs') <> 0 then do
      Call RxFuncAdd 'SysLoadFuncs','RexxUtil','SysLoadFuncs'
      Call SysLoadFuncs
   end
   lynx = "LYNX/2 2.8.5"

   parse source . . pgm .
   lxdrv = filespec('d', pgm)
   lxdir = filespec('p', pgm)
   basedir = lxdrv || lxdir
   dir = directory( delstr(basedir, length(basedir)))
   unixdir = translate(basedir, '/', '\')
   lynxhelp = "file://localhost/"unixdir"lib/lynx_help/lynx_help_main.html.gz"
   starter = basedir || "bin\RUNLYNX.CMD"
   call sysfiledelete starter
return /* init_prog */


build_dirs:

   say "Creating home and tmp subdirectories..."
   call sysmkdir "home"
   call sysmkdir "tmp"
   call sysmkdir "incoming"

   if stream(basedir || "home\lynx.cfg", 'c', 'query exist') = '' then do
      "@copy" basedir"\lib\lynx.cfg home\lynx.cfg >nul 2>nul"
      call lineout "home\lynx.cfg", "helpfile:"lynxhelp
      call lineout "home\lynx.cfg"
   end

   if stream(basedir || "home\lynx.lss", 'c', 'query exist') = '' then do
      "@copy" basedir"\lib\lynx.lss home\lynx.lss >nul 2>nul"
   end

   if stream(basedir || "home\.wgetrc", 'c', 'query exist') = '' then do
      "@copy" basedir"lib\wgetrc home\.wgetrc >nul 2>nul"
   end
return /* build_dirs */


build_starter:

   say "Creating startup program runlynx.cmd..."
   call lineout starter, "rem RUNLYNX.CMD: generated by LYNXINST.cmd script"
   call lineout starter, "    "
   call lineout starter, "@echo off"
   call lineout starter, "@setlocal"
   call lineout starter,"@set beginlibpath="basedir"dll;"
   call lineout starter, "@set home="unixdir"home"
   call lineout starter, "@set terminfo="unixdir"share/terminfo"
   call lineout starter, "@SET TERM=ansi-color-2"
   call lineout starter, "@set temp="unixdir"tmp"
   call lineout starter, "@set lynx_cfg="unixdir"home/lynx.cfg"
   call lineout starter, "@set lynx_lss="unixdir"home/lynx.lss"
/*   call lineout starter, "@SET WWW_HOME=http://www.ibm.com"*/
   call lineout starter, "@"lxdrv
   call lineout starter, "@cd"lxdir"bin"
   call lineout starter, "@"basedir"bin\lynx.exe %1 %2 %3 %4 %5 %6"
   call lineout starter, "@if errorlevel 1 goto error"
   call lineout starter, "@goto fin"
   call lineout starter, ":error"
   call lineout starter, "@pause"
   call lineout starter, ":fin"
   call lineout starter, "@endlocal"
   call lineout starter
   return /* build_starter */


update_desktop:

   say "Creating lynx/2 2.8.5 folder and objects on desktop..."

   call sysdestroyobject "<LYNX_FOLDER>"
   Call SysCreateObject,
         "WPFolder",,
         "LYNX/2 2.8.5",,
         "<WP_DESKTOP>",,
         "OBJECTID=<LYNX_FOLDER>;"||,
         "ICONFILE="||basedir||"lib\html.ico;",,
         "REPLACE"
   if result <> 1 then call error "Cannot create LYNX/2 folder"

   call sysdestroyobject "<LYNX_CFG>"
   call SysCreateObject,
      'WPProgram',,
      'EDIT LYNX CONFIGURATION FILE',,
      '<LYNX_FOLDER>',,
      'EXENAME=E.EXE;'||,
      ';OBJECTID=<LYNX_CFG>;'||,
      ';PARAMETERS='basedir'home\lynx.cfg;',,
                        'replace'
   if result <> 1 then call error "Cannot create EDIT LYNX CONFIGURATION FILE object"

   exename = basedir"bin\runlynx.cmd"
   call sysdestroyobject "<LYNX_HLP>"
   call SysCreateObject,
      'WPProgram',,
      'LYNX/2 HELP',,
      '<LYNX_FOLDER>',,
      'EXENAME='exename';'||,
      ';OBJECTID=<LYNX_HLP>;'||,
      ";ICONFILE="||basedir||"lib\lynx.ico;"||,
      ';PARAMETERS='lynxhelp';'||,
                        'replace'
   if result <> 1 then call error "Cannot create LYNX HELP OBJECT"

   call sysdestroyobject "<LYNX_PGM>"
   call SysCreateObject,
      'WPProgram',,
      'LYNX/2 BROWSER',,
         "<LYNX_FOLDER>",,
      'EXENAME='exename';'||,
      ';OBJECTID=<LYNX_PGM>;'||,
      ";ICONFILE="||basedir||"lib\lynx.ico;"||,
                        'replace'
   if result <> 1 then call error "Cannot create LYNX/2 object"
return /* update_desktop */


error:

   parse arg msg
   say msg
exit /* error */
